Subject: Re: [rmcat] draft-singh-rmcat-adaptive-fec-00

From: Ingemar Johansson S <[email-masked]>
Date: Sun, 6 Jul 2014 21:54:02 +0000

Hi

A few comments to section 3.4 and on how I believe FEC can work with SCReAM.

First of all it would be necessary to add also the payload type info in the feedback messages, this to be able to distinguish between ACK of the normal RTP packets and ACK of the FEC RTP packets. This should make it possible to properly determine the number of bytes in flight and keep the ACK clocking running. A second requirement is that the feedback reports must report the sequence numbers of received RTP (i.e before FEC has done its magic)

On the sender side the FEC RTP packets are added to the send buffer just like the normal RTP packets.

Once this is in place the detailed packet loss info in SCReAM will help the adaptive FEC framework to select the appropriate level of FEC.

/Ingemar

=================================
Ingemar Johansson  M.Sc.
Senior Researcher

Ericsson AB
Wireless Access Networks
Labratoriegränd 11
971 28, Luleå, Sweden
Phone +46-1071 43042
SMS/MMS +46-73 078 3289
[email-masked]<mailto:[email-masked]>
www.ericsson.com

"The difference between stupidity and
genius is that genius has its limits."
Albert Einstein
=================================

---

From: Sergio Garcia Murillo <[email-masked]>
Date: Mon, 07 Jul 2014 10:26:46 +0200

On 06/07/2014 23:54, Ingemar Johansson S wrote:
> First of all it would be necessary to add also the payload type info 
> in the feedback messages, this to be able to distinguish between ACK 
> of the normal RTP packets and ACK of the FEC RTP packets. This should 
> make it possible to properly determine the number of bytes in flight 
> and keep the ACK clocking running. A second requirement is that the 
> feedback reports must report the sequence numbers of received RTP (i.e 
> before FEC has done its magic)
>
> Once this is in place the detailed packet loss info in SCReAM will 
> help the adaptive FEC framework to select the appropriate level of FEC.
>
>
Hi Ingemar,

Most probably I am missing something, but shouldn't the FEC and the 
primary stream be different RTP streams? that's it, each one should have 
their own ssrc value, so your requirements above should be fulfilled 
already.

Best regards
Sergio

---

From: "Ali C. Begen (abegen)" <[email-masked]>
Date: Mon, 7 Jul 2014 08:30:05 +0000

On Jul 7, 2014, at 5:26 PM, Sergio Garcia Murillo <[email-masked]> wrote:

> Most probably I am missing something, but shouldn't the FEC and the primary stream be different RTP streams? that's it, each one should have their own ssrc value, so your requirements above should be fulfilled already.

Not all FEC schemes work that way but this is obviously the preferred (and correct) way of doing FEC for RTP. See RFC 6363.

---

From: Sergio Garcia Murillo <[email-masked]>
Date: Mon, 07 Jul 2014 10:41:29 +0200

> Not all FEC schemes work that way but this is obviously the preferred (and correct) way of doing FEC for RTP. See RFC 6363.
Sure! I was expecting doing FEC in the correct way!! ;)

Shouldn't we add that to the draft?

Best regards
Sergio

---

From: Ingemar Johansson S <[email-masked]>
Date: Mon, 7 Jul 2014 19:25:56 +0000

Hi 

Thanks for the clarificaion, this of course simplifies things even though it is not overly complex to add PT in the feedback, just a little more overhead.

/Ingemar 

> -----Original Message-----
> From: Sergio Garcia Murillo [mailto:[email-masked]]
> Sent: den 7 juli 2014 10:41
> To: Ali C. Begen (abegen)
> Cc: [email-masked]
> Subject: Re: [rmcat] draft-singh-rmcat-adaptive-fec-00
> 
> >>> First of all it would be necessary to add also the payload type info in the
> feedback messages, this to be able to distinguish between ACK of the normal
> RTP packets and ACK of the FEC RTP packets. This should make it possible to
> properly determine the number of bytes in flight and keep the ACK clocking
> running. A second requirement is that the feedback reports must report the
> sequence numbers of received RTP (i.e before FEC has done its magic)
> >>>
> >>> Once this is in place the detailed packet loss info in SCReAM will help the
> adaptive FEC framework to select the appropriate level of FEC.
> >>>
> >> Hi Ingemar,
> >>
> their own ssrc value, so your requirements above should be fulfilled already.
> > Not all FEC schemes work that way but this is obviously the preferred (and
> correct) way of doing FEC for RTP. See RFC 6363.
> >